
#include <avr/io.h>
#include <Wire.h>

#define PIN_LED_LEFT  8
#define PIN_LED_RIGHT 9

String inputString = "";

int locker_number = -1;

boolean RFID_event = false;  // whether the string is complete

struct locker_information {
  String locker_key;
  char locker_number;
};

locker_information locker_array[8] = { { "",-1 },{ "",-1 },{ "",-1 },{ "",-1 },{ "",-1 },{ "",-1 },{ "",-1 },{ "",-1 } };


bool key_already_in_use(String key, int &locker_number)
{
  for (int iterator = 0; iterator < 8; iterator++)
  {
    if (locker_array[iterator].locker_key.equals(key))
    {
      locker_array[iterator].locker_key = "";

      locker_number = locker_array[iterator].locker_number;
      locker_array[iterator].locker_number = -1;
      return true;
    }
  };
  return false;
}

bool reserve_first_free_locker(String key, int &locker_number)
{
  for (int iterator = 0; iterator < 8; iterator++)
  {
    if (locker_array[iterator].locker_key.equals("") && locker_array[iterator].locker_number == -1)
    {
      locker_array[iterator].locker_key = key;

      locker_number = iterator + 8;
      locker_array[iterator].locker_number = locker_number;
      return true;
    }
  };
  return false;
}


void setup()
{
  delay(500);
  Serial.begin(9600);
  pinMode(PIN_LED_LEFT,OUTPUT);
  pinMode(PIN_LED_RIGHT,OUTPUT);
  
  Wire.begin();// join i2c bus (address optional for master)

//  pinMode(PIN, OUTPUT);
}

void loop()
{
  
  if (RFID_event)
  {
    if (key_already_in_use(inputString, locker_number))
    {
      //Toggle linke LED, um anzuzeigen, ob Öffnen-Befehl über I2C rausgeht
      digitalWrite(PIN_LED_LEFT,!(digitalRead(PIN_LED_LEFT)));
      /*
      Serial.println("OPEN");
      Serial.print(locker_number);
      delay(50);
      */
      
      Wire.beginTransmission(locker_number); // transmit to device
      //delay(10);
      Wire.write('1');
      // delay(10);
      Wire.endTransmission();
      
      
    }
    else
    {
      if (reserve_first_free_locker(inputString, locker_number))
      {
        //Toggle rechte LED, um anzuzeigen, ob Schließbefehl über I2C rausgeht
        digitalWrite(PIN_LED_RIGHT,!(digitalRead(PIN_LED_RIGHT)));
     
        /*
        Serial.println("CLOSE");
        Serial.print(locker_number);
        delay(50);
        */
      
        Wire.beginTransmission(locker_number);
        //delay(10);
        Wire.write('2');
        //delay(10);
        Wire.endTransmission();
       
      }
    }
    inputString = "";
    RFID_event = false;
    
  }






  //start i2c communication
  /*
  Wire.beginTransmission(8); // transmit to device
  Wire.write('1');

  if (inputRFID == true)
  {
    digitalWrite(PIN, HIGH);    // sets the LED of
    delay(3000);
    inputRFID = false;
  }
  else digitalWrite(PIN, LOW);


  //stringComplete = false;      
  // clear the string:
  // Serial.println(inputString);
  // inputString = "Test:";
  */
}

/*
SerialEvent occurs whenever a new data comes in the
hardware serial RX.  This routine is run between each
time loop() runs, so using delay inside loop can delay
response.  Multiple bytes of data may be available.
*/
    
void serialEvent() 
{
  delay(50);
  while (Serial.available())
  {
    // get the new byte:
    char inChar = (char)Serial.read();
    // add it to the inputString:
    inputString += inChar;
    // if the incoming character is a newline, set a flag
    // so the main loop can do something about it:

  }
  RFID_event = true;
}
